# muscle::ZLibCodec class [(API)](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ZLibCodec.html)

```#include "zlib/ZLibCodec.h"```

ZlibCodec is a wrapper API around the ZLib compression library's useful (but difficult-to-use-correctly) `inflate()` and `deflate()` functions.

* [Deflate()](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ZLibCodec.html#aa29aa79e18c4de887e3e0cc43c7876c7) takes a pointer to a buffer of raw data, and returns a [ByteBufferRef](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ByteBuffer.html) containing equivalent (but hopefully smaller) deflated data.
* [Inflate()](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ZLibCodec.html#a40980143bf247e8cbe44b7f114991bef) takes a pointer to a buffer of deflated data (as previously generated by [Deflate()](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ZLibCodec.html#aa29aa79e18c4de887e3e0cc43c7876c7) and returns a [ByteBufferRef](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ByteBuffer.html) containing the original raw data.
* [ReadAndDeflateAndWrite()](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ZLibCodec.html#ab8ec37a82940c9f6f02b32cfa500c303) can be used to deflate large raw-data files without having to read the entire raw-data file into memory first.
* [ReadAndInflateAndWrite()](https://public.msli.com/lcs/muscle/html/classmuscle_1_1ZLibCodec.html#a565f2b388d1249b7322ade31a6388760) can be used to inflate large deflated files without having to read the entire deflated-data file into memory first.

Try compiling and running the mini-example-programs in `muscle/html/muscle-by-example/examples/zlibcodec` (enter `make` to compile example_*, and then run each from Terminal while looking at the corresponding .cpp file)

Quick links to source code of relevant MUSCLE-by-example programs:

* [zlibcodec/example_1_basic_usage.cpp](https://public.msli.com/lcs/muscle/muscle/html/muscle-by-example/examples/zlibcodec/example_1_basic_usage.cpp)
* [zlibcodec/example_2_dependent_series.cpp](https://public.msli.com/lcs/muscle/muscle/html/muscle-by-example/examples/zlibcodec/example_2_dependent_series.cpp)
